Imports System.Math
Module Affichage_Note_de_Calcul
    Friend WithEvents ThisApplication As Word.Application
    Friend WithEvents ThisDocument As Word.Document
    Private selTextSelectionne As Word.Selection
    Private cDerniereLettre As Char
    Public Sub Note_de_calcul()
        Try
            CreationDocument()
            InitialisationDocument()
            EcrireFichier()
            'Affiche Word
            ThisApplication.Visible = True

        Catch ex As Exception
            If Err.Number = 5825 Then
                'Normal => Objet Word detruit (surement du a la fermeture du formulaire pendant l'execution)
            Else
                DestructionDocument()
                Throw ex
            End If
        End Try
    End Sub
    Private Sub CreationDocument()
        'rtbEtat.AppendText("Cration de l'application word et du document." & vbNewLine)
        'Me.Refresh()
        'Me.Update()
        'Application.DoEvents()

        DestructionDocument() 'Detruit les variabble pour ne pas cr de document orphelin si on clique 2 fois sur le bouton
        ThisApplication = New Word.Application
        ThisApplication.Visible = False 'Masque Word
        ThisDocument = ThisApplication.Documents.Add 'Ajoute un document
    End Sub
    Private Sub InitialisationDocument()
        'rtbEtat.AppendText("Mise en forme du document Word." & vbNewLine)
        'Me.Refresh()
        'Me.Update()
        'Application.DoEvents()

        ThisDocument.Range.Font.Name = "arial" 'Defini la police de caractre
        ThisDocument.PageSetup.TextColumns.SetCount(1) 'Impose 1 colonnes au document
        'ThisDocument.PageSetup.TextColumns.LineBetween = CInt(True) 'Insert une ligne verticale entre chaque colonne
        ThisDocument.PageSetup.OddAndEvenPagesHeaderFooter = CInt(True) 'Indique que les Pages paires et impaires seront traites diffrement (pour les entetes et pieds de page ici)

        'Definit les entetes des pages paires
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Text = "Poteau en bton arm: note de calcul"
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Font.Name = "arial"
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Italic = CInt(True)
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Font.Size = 10

        'Definit les entetes des pages impaires
        'les 2 tabulation aligne automatique le texte a droite sur les TabStop Automatique de Word (le premier est un centrage)
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Text = vbTab & vbTab & "Note de calcul"
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Font.Name = "arial"
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Italic = CInt(True)
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Font.Size = 10

        'Definit les entetes des pages paires et impaire
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Font.Name = "arial"
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Italic = CInt(True)
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Font.Size = 10
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Font.Name = "arial"
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Italic = CInt(True)
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Font.Size = 10

        'Ajoute les numro de page sur l'exterieus des page dans les pied de page
        'Force le redemarrage du comptage de la section (ici une seule section celle par default donc tous le docuemnt)
        'Le redemarrage commence a 34
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).PageNumbers.Add(Word.WdPageNumberAlignment.wdAlignPageNumberOutside)
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).PageNumbers.RestartNumberingAtSection = True
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).PageNumbers.StartingNumber = 1

        ThisDocument.Range.Select() 'Defini "selTextSelectionne" comme une plage recouvrant tout le document
        selTextSelectionne = ThisApplication.Selection
    End Sub
    Private Sub DestructionDocument()
        'rtbEtat.AppendText("Destruction des objets utiliss" & vbNewLine)
        'Me.Refresh()
        'Me.Update()
        Application.DoEvents()

        If Not (ThisApplication Is Nothing) Then
            Try
                'Ferme l'application sans enregistr le document
                ThisApplication.Quit(Word.WdSaveOptions.wdDoNotSaveChanges)
            Catch ex As System.Runtime.InteropServices.COMException
                'l'application a t ferm par l'utilisateur
            End Try
        End If
        'tbDonnees = Nothing
        ThisDocument = Nothing
        ThisApplication = Nothing
    End Sub

    Private Sub EcrireFichier()
        Dim str, F1, F2, F3, F4, F5, F6, F7 As String
        Dim i, i1, i2, j As Integer

        'VerifeNouvelleLetre(Mid(tbDonnees(nIndex).sNom, 1, 1))

        'Dim dbutSlection As Integer = selTextSelectionne.Range.Start
        'selTextSelectionne.TypeText(tbDonnees(nIndex))

        'Mesure des tabstops => 1000 point = 352.7 mm
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count).TabStops.Add((1000 / 352.7 * 75), Word.WdTabAlignment.wdAlignTabRight)
        selTextSelectionne.TypeText(vbTab)

        selTextSelectionne.TypeText("Note de Calcul")
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Bold = 0
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Color = Word.WdColor.wdColorBlue
        'ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 14
        selTextSelectionne.TypeText(vbCrLf)

        Str = "I - Rappel des hypothses :"
        selTextSelectionne.TypeText(Str)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Underline = Word.WdUnderline.wdUnderlineSingle
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 11
        selTextSelectionne.TypeText(vbCrLf)


        str = "Semelle sur pieux " : Affichage(str)
        F1 = Format(Ty, "##")
        str = "Nombre de type de pieux: " & F1 : Affichage(str)
        For i = 1 To Ty
            F1 = Format(i, "##")
            str = "Pieu de type n" & F1 : Affichage(str)
            F1 = Format(dp(i) * 100, "##")
            str = "Diamtre :" & F1 & " cm" : Affichage(str)
        Next


        selTextSelectionne.TypeText(vbCrLf)

        selTextSelectionne.TypeText("II - Efforts et dplacements des pieux :")
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Underline = Word.WdUnderline.wdUnderlineSingle
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 11
        selTextSelectionne.TypeText(vbCrLf)

        For i = 1 To Ty
            F1 = Format(i, "##")
            str = "COEFFICIENTS CROISES  en tte du pieu de type n" & F1 & " :" : Affichage1(str)
            str = "Sous efforts SOUTENUS :" : Affichage2(str)
            F1 = Format(ro1(1, i), "#0.00000") : F2 = Format(ro2(1, i), "#0.00000") : F3 = Format(ro3(1, i), "#0.00000")
            str = "ro1=" & F1 : Affichage(str)
            str = "ro2= " & F2 : Affichage(str)
            str = "ro3 =" & F3 : Affichage(str)
            str = "Sous efforts INSTANTANES :" : Affichage2(str)
            F1 = Format(ro1(2, i), "#0.00000") : F2 = Format(ro2(2, i), "#0.00000") : F3 = Format(ro3(2, i), "#0.00000")
            str = "ro1=" & F1 : Affichage(str)
            str = "ro2= " & F2 : Affichage(str)
            str = "ro3 =" & F3 : Affichage(str)
        Next
        selTextSelectionne.TypeText(vbCrLf)

        str = "Dplacements de la semelle :" : Affichage2(str)
        str = "Sous efforts soutenus :" : Affichage1(str)
        F1 = Format(z0(1) * 1000, "#0.0000")
        str = "dz0 (mm) = " & F1 : Affichage(str)
        F1 = Format(om0(1) * 1000, "#0.0000")
        str = "om0 (10e-3.rad) = " & F1 : Affichage(str)
        F1 = Format(y0(1) * 1000, "#0.0000")
        str = "dy0 (mm) = " & F1 : Affichage(str)

        str = "sous efforts instantans :" : Affichage1(str)
        F1 = Format(z0(2) * 1000, "#0.0000")
        str = "dz0 (mm) = " & F1 : Affichage(str)
        F1 = Format(om0(2) * 1000, "#0.0000")
        str = "om0 (10e-3.rad) = " & F1 : Affichage(str)
        F1 = Format(y0(2) * 1000, "#0.0000")
        str = "dy0 (mm) = " & F1 : Affichage(str)
        selTextSelectionne.TypeText(vbCrLf)

        str = "sous efforts cumuls :" : Affichage1(str)
        F1 = Format((z0(1) + z0(2)) * 1000, "#0.0000")
        str = "dz0 (mm) = " & F1 : Affichage(str)
        F1 = Format((om0(1) + om0(2)) * 1000, "#0.0000")
        str = "om0 (10e-3.rad) = " & F1 : Affichage(str)
        F1 = Format((y0(1) + y0(2)) * 1000, "#0.0000")
        str = "dy0 (mm) = " & F1 : Affichage(str)
        selTextSelectionne.TypeText(vbCrLf)

        For i = 1 To Ty
            F1 = Format(i, "##")
            str = "Efforts sur les pieux de type n " & F1 & " :" : Affichage2(str)
            For j = 1 To nf(i)
                F1 = Format(j, "##")
                str = "file n " & F1 & " :" : Affichage(str)
                str = "sous efforts soutenus :" : Affichage1(str)
                F1 = Format(n(1, i, j), "#0.0000")
                str = "N (KN) = " & F1 : Affichage(str)
                F1 = Format(m(1, i, j, 0), "#0.0000")
                str = "M (KN.m) = " & F1 : Affichage(str)
                F1 = Format(t(1, i, j, 0), "#0.0000")
                str = "T (KN) = " & F1 : Affichage(str)

                str = "sous efforts instantans :" : Affichage1(str)
                F1 = Format(n(2, i, j), "#0.0000")
                str = "N (KN) = " & F1 : Affichage(str)
                F1 = Format(m(2, i, j, 0), "#0.0000")
                str = "M (KN.m) = " & F1 : Affichage(str)
                F1 = Format(t(2, i, j, 0), "#0.0000")
                str = "T (KN) = " & F1 : Affichage(str)

                str = "sous efforts cumuls :" : Affichage1(str)
                F1 = Format(n(3, i, j), "#0.0000")
                str = "N (KN) = " & F1 : Affichage(str)
                F1 = Format(m(3, i, j, 0), "#0.0000")
                str = "M (KN.m) = " & F1 : Affichage(str)
                F1 = Format(t(3, i, j, 0), "#0.0000")
                str = "T (KN) = " & F1 : Affichage(str)
            Next
        Next i
        selTextSelectionne.TypeText(vbCrLf)

        For i = 1 To Ty
            j = 1
            F1 = Format(i, "##")
            str = "PIEU DE TYPE n " & F1 & " :" : Affichage(str)
            str = "sous efforts SOUTENUS :" : Affichage(str)
            'For i1 = 1 To 10 'z.GetLength(1) - 1
            '    'Dim toto As Integer
            '    'toto = z.GetLength(1) - 1
            '    F1 = Format(z(i, i1), "#0.000")
            '    str = "profondeur" & F1 & "(m)" : Affichage(str)
            '    F1 = Format(yy(j, i, i1) * 1000, "#0.0")
            '    str = "deplacement" & F1 & "(mm)" : Affichage(str)
            '    F1 = Format(m(j, i, i1), "#0.000")
            '    str = "moment" & F1 & "(MN.m)" : Affichage(str)
            '    F1 = Format(t(j, i, i1), "#0.000")
            '    str = "effort tranchant" & F1 & "(MN)" : Affichage(str)
            '    F1 = Format(pl(j, i, i1), "#0.000")
            '    str = "pression limite" & F1 & "(MPa)" : Affichage(str)
            'Next i1
            j = 2
            str = "sous efforts INSTANTANES :" : Affichage(str)
            'For i1 = 1 To 10 'z.GetLength(1) - 1
            '    F1 = Format(z(i, i1), "#0.000")
            '    str = "profondeur" & F1 & "(m)" : Affichage(str)
            '    F1 = Format(yy(j, i, i1) * 1000, "#0.0")
            '    str = "deplacement" & F1 & "(mm)" : Affichage(str)
            '    F1 = Format(m(j, i, i1), "#0.000")
            '    str = "moment" & F1 & "(MN.m)" : Affichage(str)
            '    F1 = Format(t(j, i, i1), "#0.000")
            '    str = "effort tranchant" & F1 & "(MN)" : Affichage(str)
            '    F1 = Format(pl(j, i, i1), "#0.000")
            '    str = "pression limite" & F1 & "(MPa)" : Affichage(str)
            'Next i1
        Next
        selTextSelectionne.TypeText(vbCrLf)


        selTextSelectionne.TypeText("III - Rsultats enveloppe :")
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Underline = Word.WdUnderline.wdUnderlineSingle
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 11
        selTextSelectionne.TypeText(vbCrLf)
        str = "Attention:  les valeurs ci-dessous sont donnes en valeurs absolues" : Affichage(str)
        selTextSelectionne.TypeText(vbCrLf)
        For i = 1 To Ty
            j = 1
            F1 = Format(i, "##")
            str = "PIEU DE TYPE n " & F1 & " :" : Affichage(str)
            str = "sous efforts SOUTENUS :" : Affichage(str)
            For i1 = 1 To nf(i)
                F1 = Format(max_M(j, i, i1), "##0.000")
                str = "Moment maximal " & F1 & "(KN.m)" : Affichage(str)
                F1 = Format(max_T(j, i, i1), "##0.000")
                str = "Effort tranchant maximal " & F1 & "(KN)" : Affichage(str)
                F1 = Format(max_Rot(j, i, i1) * 1000, "#0.000")
                str = "Rotation maximale " & F1 & "(rad.10e3)" : Affichage(str)
                F1 = Format(max_Depl(j, i, i1) * 1000, "####0.00")
                str = "Dplacement maximal " & F1 & "(mm)" : Affichage(str)
                F1 = Format(max_Pl(j, i, i1), "####0.00")
                str = "Pression Limite maximale " & F1 & "(KPa)" : Affichage(str)
            Next i1
            j = 2
            For i1 = 1 To nf(i)
                str = "sous efforts INSTANTANES :" : Affichage(str)
                F1 = Format(max_M(j, i, i1), "##0.000")
                str = "Moment maximal " & F1 & "(KN.m)" : Affichage(str)
                F1 = Format(max_T(j, i, i1), "##0.000")
                str = "Effort tranchant maximal " & F1 & "(KN)" : Affichage(str)
                F1 = Format(max_Rot(j, i, i1) * 1000, "#0.000")
                str = "Rotation maximale " & F1 & "(rad.10e3)" : Affichage(str)
                F1 = Format(max_Depl(j, i, i1) * 1000, "####0.00")
                str = "Dplacement maximal " & F1 & "(mm)" : Affichage(str)
                F1 = Format(max_Pl(j, i, i1), "####0.00")
                str = "Pression Limite maximale " & F1 & "(KPa)" : Affichage(str)
            Next
            j = 3
            For i1 = 1 To nf(i)
                str = "sous efforts CUMULES :" : Affichage(str)
                F1 = Format(max_M(j, i, i1), "##0.000")
                str = "Moment maximal " & F1 & "(KN.m)" : Affichage(str)
                F1 = Format(max_T(j, i, i1), "##0.000")
                str = "Effort tranchant maximal " & F1 & "(KN)" : Affichage(str)
                F1 = Format(max_Rot(j, i, i1) * 1000, "#0.000")
                str = "Rotation maximale " & F1 & "(rad.10e3)" : Affichage(str)
                F1 = Format(max_Depl(j, i, i1) * 1000, "####0.00")
                str = "Dplacement maximal " & F1 & "(mm)" : Affichage(str)
                F1 = Format(max_Pl(j, i, i1), "####0.00")
                str = "Pression Limite maximale " & F1 & "(KPa)" : Affichage(str)
            Next
        Next
        selTextSelectionne.TypeText(vbCrLf)
        If phiALproj(1, 1) < 0.001 Then Exit Sub

        selTextSelectionne.TypeText("IV - Calcul ferraillage :")
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Underline = Word.WdUnderline.wdUnderlineSingle
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 11
        selTextSelectionne.TypeText(vbCrLf)
        For i2 = 1 To Ty
            j = 1
            F1 = Format(i2, "##")
            str = "PIEU DE TYPE n " & F1 & " :" : Affichage(str)
            For i1 = 1 To nf(i2)
                F1 = Format(i1, "##")
                str = "fILE n " & F1 & " :" : Affichage(str)
                str = "Calcul  l'Etat Limite Ultime :" : Affichage(str)
                F1 = Format(Yn0(i2, i1), "#0.000")
                str = "Axe neutre Y0 (m) = " & F1 : Affichage(str)
                F1 = Format(Nrb(i2, i1), "#0.000")
                str = "N rsistant bton (Kn) = " & F1 : Affichage(str)
                F1 = Format(Nra(i2, i1), "#0.000")
                str = "N rsistant acier (Kn) = " & F1 : Affichage(str)
                F1 = Format(Nrb(i2, i1) + Nra(i2, i1), "#0.000")
                str = "N rsistant Total (Kn) = " & F1 : Affichage(str)
                F1 = Format(Mrb(i2, i1), "#0.000")
                str = "M rsistant bton(Kn.m) = " & F1 : Affichage(str)
                F1 = Format(Mra(i2, i1), "#0.000")
                str = "M rsistant acier(Kn.m) = " & F1 : Affichage(str)
                F1 = Format(Mra(i2, i1) + Mrb(i2, i1), "#0.000")
                str = "M rsistant Total(Kn.m) = " & F1 : Affichage(str)
                str = " " : Affichage(str)

                str = "Calcul  l'Etat Limite de Service :" : Affichage(str)
                F1 = Format(Sb(i2, i1), "#0.00")
                str = "Contrainte maximale bton sur la fibre suprieure(MPa) = " & F1 : Affichage(str)
                For i = 1 To 1 'couronne
                    F1 = Format(Sa(i2, i1, i), "#0.00")
                    str = "Contrainte acier n" & CStr(i) & " (MPa) = " & F1 : Affichage(str)
                Next
                F1 = Format(Sbmoy(i2, i1), "#0.00")
                str = "Contrainte moyenne sur le bton comprim (MPa) = " & F1 : Affichage(str)
                str = " " : Affichage(str)
            Next

        Next
        '''''''Dim finSlection As Integer = selTextSelectionne.Range.End

        ''''''''If nIndex < tbDonnees.GetUpperBound(0) Then
        ''''''''    If cDerniereLettre = Mid(tbDonnees(nIndex + 1).sNom, 1, 1) Then
        'Fermeture de l'lve par une bordure infrieure
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Borders.Item(Word.WdBorderType.wdBorderBottom).Visible = True
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Borders.Item(Word.WdBorderType.wdBorderBottom).Color = Word.WdColor.wdColorBlue
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Borders.Item(Word.WdBorderType.wdBorderBottom).LineWidth = Word.WdLineWidth.wdLineWidth225pt
        ''''''''    End If
        ''''''''End If

        ''''''''ThisDocument.Range(dbutSlection, finSlection).Select()
        '''''''ThisApplication.Selection.ParagraphFormat.KeepWithNext = CInt(True)
        '''''''selTextSelectionne.SetRange(ThisDocument.Range.End, ThisDocument.Range.End)
    End Sub
    Private Sub Affichage(ByVal toto As String)
        selTextSelectionne.TypeText(toto)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 9
    End Sub
    Private Sub Affichage1(ByVal toto As String) 'taille 10, gras
        selTextSelectionne.TypeText(toto)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 10
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Bold = CInt(True)
    End Sub
    Private Sub Affichage2(ByVal toto As String) 'taille 9, soulign
        selTextSelectionne.TypeText(toto)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 9
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Underline = Word.WdUnderline.wdUnderlineWords
    End Sub
End Module
